from .resnet import resnet20, resnet32
from .wrn import wrn_40_2
from .vgg import vgg8_bn
from .mobilenetv2 import mobile_half
from .ShuffleNetv2 import ShuffleV2

model_dict = {
    'resnet20': resnet20,
    'resnet32': resnet32,
    'wrn_40_2': wrn_40_2,
    'vgg8': vgg8_bn,
    'MobileNetV2': mobile_half,
    'ShuffleV2': ShuffleV2,
}
